#include "PublicSDKMotion.h"

class JumpHouse : public PublicSDKMotion
{
	public:
		JumpHouse();

		virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
			int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
			int jump, int down, int rssi);

		bool unzuptValid(int* max_acc, int* min_acc);
	private:

		deque<int> rssi_vec;
		deque<int> pitch_vec;
		deque<int> roll_vec;
		deque<int> left_acc_vec;
		deque<int> right_acc_vec;

		int pitch_reference_val = 0;
		int roll_reference_val = 0;

		int has_init = 0;

		deque<shoes_data_cell> left_shoes_data_vector;
		deque<shoes_data_cell> right_shoes_data_vector;

		deque<shoes_data_cell> left_step_data_vector;
		deque<shoes_data_cell> right_step_data_vector;

		int left_acc_buff[3][3];
		int right_acc_buff[3][3];

		deque<int> left_acc_x_vector;
		deque<int> right_acc_x_vector;



		float left_heading;
		float right_heading;

		int right_cmd_wait_time;
		int left_cmd_wait_time;

		int left_init;
		int right_init;

		int left_zupt_extension_time = 0;
		int right_zupt_extension_time = 0;


		const int rssi_threshold = 25;

};