

#include "PublicSDKMotion.h"

class RunGame : public PublicSDKMotion {
public:
	RunGame();

	void setStepHeading(float& cur_heading, float heading);

	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);

	int rssiFeature(deque<shoes_data_cell>& shoes_data_vector);

	int getResultJump(int jump);
	int getResultDown(int down);

private:
	deque<shoes_data_cell> left_shoes_data_vector;
	deque<shoes_data_cell> right_shoes_data_vector;

	float left_step_heading;
	float right_step_heading;

	deque<shoes_data_cell> left_step_data_vector;
	deque<shoes_data_cell> right_step_data_vector;

	float left_step_pos[3];
	float right_step_pos[3];

	int jump_count;
	int down_count;

	int last_down;
	int last_canva_down;
	int last_jump;

	int down_wait_after_jump;

	float left_heading;
	float right_heading;

	int left_zupt_count;
	int right_zupt_count;

	int last_left_zupt;
	int last_right_zupt;

	//߹ݴʦ⴦׿Ч
	deque<int> left_acc_deque;
	deque<int> right_acc_deque;
	int wait_down = 0;

};
