#include "FingerGuessing.h"

#

FingerGuessing::FingerGuessing()
{
	left_foot_has_init = 0;
	right_foot_has_init = 0;

	left_heading = 0;
	right_heading = 0;

	left_zupt_count = 0;
	right_zupt_count = 0;


	right_cmd_wait_time = 0;
	left_cmd_wait_time = 0;

	memset(left_cmd_global_pos, 0, 3 * sizeof(float));
	memset(right_cmd_global_pos, 0, 3 * sizeof(float));

	left_init = 0;
	right_init = 0;

	//ԭ
	left_global_pos_vector.push_back({ 0, 0, 0, 0 });
	right_global_pos_vector.push_back({ 0, 0, 0, 0 });

}


void FingerGuessing::ProcessResult(float* global_pos, deque<shoes_data_cell>& step_data_vector,
	deque<globalPos_struct>& global_pos_vector, int LEFT_OR_RIGHT)
{

	if (step_data_vector.size() > 1 && step_data_vector.front().zupt == 1 && step_data_vector.back().zupt == 1)
	{
		if (LEFT_OR_RIGHT == LEFT_FOOT)
		{
			std::cout << "Left Foot : " << endl << endl;
		}
		else
		{
			std::cout << "Right Foot : " << endl << endl;
		}

		std::cout << "FingerGuessing::ProcessResult" << endl;
		std::cout << endl;

		//ѰҵСֵ
		int vector_length = global_pos_vector.size();

		float distance_point = 0.05f;

		int index = -1;


		for (int i = 0; i < vector_length; i++)
		{
			//Ѱȹĵ
			float dx = global_pos[0] - global_pos_vector.at(i).pos_x;
			float dy = global_pos[1] - global_pos_vector.at(i).pos_y;

			float distance_temp = sqrt(dx * dx + dy * dy);

			float global_pos_distance = sqrt(global_pos_vector.at(i).pos_x * global_pos_vector.at(i).pos_x + global_pos_vector.at(i).pos_y * global_pos_vector.at(i).pos_y);

			if (i == 0 && distance_temp < distance_point)
			{

				index = i;

				distance_point = distance_temp;

			}
			else if (i != 0 && distance_temp < distance_point)
			{

				index = i;

				distance_point = distance_temp;

			}
		}


		if (index == -1)
		{
			std::cout << "no find similar point" << endl;
			//ûҵ׼ʱ򣬼⵽ʱ,ж
			//⵽ӽԭʱӦΪ0

			global_pos_vector.push_back({ 0, global_pos[0], global_pos[1],global_pos[2] });

			std::cout << " pos_x : " << global_pos_vector.back().pos_x
				<< " pos_y : " << global_pos_vector.back().pos_y
				<< " pos_z : " << global_pos_vector.back().pos_z << endl;

		}
		else
		{
			std::cout << "has find similar point, index : " << index << endl;

			global_pos[0] = global_pos_vector.at(index).pos_x;
			global_pos[1] = global_pos_vector.at(index).pos_y;
			global_pos[2] = global_pos_vector.at(index).pos_z;
		}


		/*if ( sqrt(global_pos[0] * global_pos[0] + global_pos[1] * global_pos[1]) < 0.1f)
		{

			std::cout << "if (sqrt(global_pos[0] * global_pos[0] + global_pos[1] * global_pos[1]) < 0.1f)" << endl;

			global_pos_vector.clear();

			global_pos_vector.push_back({ 0, 0, 0, 0 });

			memset(global_pos, 0, 3 * sizeof(float));
		}*/


	}

	//Ϊ˷ֹ󴥵㣬ص

}

int FingerGuessing::ProcessDualStepVector(deque<shoes_data_cell>& left_cmd_step_data_vector, deque<shoes_data_cell>& right_cmd_step_data_vector,
	float* left_cmd_global_pos, float* right_cmd_global_pos, int rssi)
{
	if (!(left_cmd_step_data_vector.size() > 2 && right_cmd_step_data_vector.size() > 2))
	{
		return -1;
	}

	float left_dx = left_cmd_step_data_vector.back().pos_x - left_cmd_step_data_vector.front().pos_x;
	float right_dx = right_cmd_step_data_vector.back().pos_x - right_cmd_step_data_vector.front().pos_x;

	float left_dy = left_cmd_step_data_vector.back().pos_y - left_cmd_step_data_vector.front().pos_y;
	float right_dy = right_cmd_step_data_vector.back().pos_y - right_cmd_step_data_vector.front().pos_y;

	if (sqrt(left_dx * left_dx + left_dy * left_dy) < 0.1f || sqrt(right_dx * right_dx + right_dy * right_dy) < 0.1f)
	{
		return -1;
	}

	//жȭͷ

	if (rssi > 30)
	{

		float dx = right_dx - left_dx;
		float dy = right_dy - left_dy;

		if (right_dx - left_dx > 0.3f)
		{
			left_cmd_global_pos[0] = -0.25f; left_cmd_global_pos[1] = 0.0f;
			right_cmd_global_pos[0] = 0.25f; right_cmd_global_pos[1] = 0.0f;

			return MOTION_PAPER;
		}

		//жϼе鷳
		if (right_dx - left_dx < -0.3f)
		{

			if (left_dy - right_dy < -0.3f)
			{
				left_cmd_global_pos[0] = 0.0f; left_cmd_global_pos[1] = -0.15f;
				right_cmd_global_pos[0] = 0.0f; right_cmd_global_pos[1] = 0.15f;
				return MOTION_SCISSORS;
			}

			if (left_dy - right_dy > 0.3f)
			{
				left_cmd_global_pos[0] = 0.0f; left_cmd_global_pos[1] = 0.15f;
				right_cmd_global_pos[0] = 0.0f; right_cmd_global_pos[1] = -0.15f;
				return MOTION_SCISSORS;
			}

		}
	}


	return -1;
}

bool FingerGuessing::unzuptValid(int* max_acc, int* min_acc)
{
	if ((max_acc[0] - min_acc[0] > 2048 || max_acc[1] - min_acc[1] > 2048 || max_acc[2] - min_acc[2] > 2048))
	{
		return true;
	}

	return false;
}


void FingerGuessing::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	//ڸմصʱ,żźŵĹؼ߲֡һ

	//int online_zupt = extract_motion.online_detect_touch_floor(right_front_press, left_front_press, right_back_press, left_back_press);

	//if (online_zupt & 0x01)
	//{
	//	std::cout << "test :: left_zupt" << endl;
	//	left_zupt = 1;
	//}
	//if (online_zupt & 0x02)
	//{
	//	std::cout << "test :: right_zupt" << endl;
	//	right_zupt = 1;
	//}

	if (has_init == 0)
	{
		rssi_vec.push_back(rssi);
		pitch_vec.push_back(left_att[1] - right_att[1]);
		roll_vec.push_back((left_att[2] + right_att[2]) * 0.5f);
		left_acc_vec.push_back(sqrt(left_acc[0] * left_acc[0] + left_acc[1] * left_acc[1] + left_acc[2] * left_acc[2]));
		right_acc_vec.push_back(sqrt(right_acc[0] * right_acc[0] + right_acc[1] * right_acc[1] + right_acc[2] * right_acc[2]));
		

		if (rssi_vec.size() > 50)
		{
			rssi_vec.pop_front();
			pitch_vec.pop_front();
			roll_vec.pop_front();
			left_acc_vec.pop_front();
			right_acc_vec.pop_front();
		}

		if (rssi_vec.size() == 50)
		{

			int max_rssi = *max_element(rssi_vec.begin(), rssi_vec.end());
			int left_max_acc = *max_element(left_acc_vec.begin(), left_acc_vec.end());
			int left_min_acc = *min_element(left_acc_vec.begin(), left_acc_vec.end());

			int right_max_acc = *max_element(right_acc_vec.begin(), right_acc_vec.end());
			int right_min_acc = *min_element(right_acc_vec.begin(), right_acc_vec.end());

			if (max_rssi < 25 && left_max_acc - left_min_acc < 510 && right_max_acc - right_min_acc < 510)
			{
				std::cout << "test" << endl;
				for (int i = 0; i < 50; i++)
				{
					pitch_reference_val += pitch_vec[i];
					roll_reference_val += pitch_vec[i];
				}
				pitch_reference_val /= 50;
				roll_reference_val /= 50;

				std::cout << "init roll and pitch  !!!!" << endl;
			}

		}

	}


	/*if (left_zupt || right_zupt)
	{
		left_zupt = 1; right_zupt = 1;
	}*/

	if (left_zupt)
	{
		left_zupt_extension_time = 5;
	}

	if (right_zupt)
	{
		right_zupt_extension_time = 5;
	}

	if (left_zupt_extension_time > 0)
	{
		left_zupt = 1;

		left_zupt_extension_time--;
	}


	if (right_zupt_extension_time > 0)
	{
		right_zupt = 1;

		right_zupt_extension_time--;
	}


	//һڵĿ
	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	//ݣȫλ
	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_heading, 0, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_heading, 0, LEFT_FOOT);


	//ϸrssiʹźƹλԼ
	resetZerosPointByRssi(left_zupt, 10, left_zupt_count, left_foot_has_init, left_att[0] * 0.0001f, left_heading, rssi, 25, left_global_pos);
	resetZerosPointByRssi(right_zupt, 10, right_zupt_count, right_foot_has_init, right_att[0] * 0.0001f, right_heading, rssi, 25, right_global_pos);


	//ͨٶȡԼvectorѾ˿еλжʱʱʱжϵЧʱΪ˵ȺʵRSSI
	if (left_step_data_vector.size() > 5 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1)
	{
		if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
		{
			//ݹ¼λõŻ
			//ProcessResult(left_global_pos, left_step_data_vector, left_global_pos_vector, LEFT_FOOT);

			left_cmd_step_data_vector = left_step_data_vector;

			float dy = left_step_data_vector.back().pos_y - left_step_data_vector.front().pos_y;
			float dx = left_step_data_vector.back().pos_x - left_step_data_vector.front().pos_x;

			if (sqrt(dx * dx + dy * dy) < 0.05)
			{
				left_global_pos[0] -= dx;
				left_global_pos[1] -= dy;
			}
			memcpy(left_cmd_global_pos, left_global_pos, 3 * sizeof(float));

			left_cmd_wait_time = time_stamp;

			left_init = 1;

		}

	}


	if (right_step_data_vector.size() > 5 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1)
	{
		if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
		{

			//ݹ¼λõŻ
			//ProcessResult(right_global_pos, right_step_data_vector, right_global_pos_vector, RIGHT_FOOT);

			right_cmd_step_data_vector = right_step_data_vector;

			float dy = right_step_data_vector.back().pos_y - right_step_data_vector.front().pos_y;
			float dx = right_step_data_vector.back().pos_x - right_step_data_vector.front().pos_x;

			if (sqrt(dx * dx + dy * dy) < 0.05)
			{
				right_global_pos[0] -= dx;
				right_global_pos[1] -= dy;
			}

			memcpy(right_cmd_global_pos, right_global_pos, 3 * sizeof(float));

			right_cmd_wait_time = time_stamp;

			right_init = 1;
		}

	}


	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);

	//
	memset(result, -1, 4 * sizeof(int));

	//ж˫Ŵصʱ, rssi < 23 λȻҲû취
	//rssiӳйõ


	if (left_init == 1 && right_init == 1 &&
		time_stamp - left_cmd_wait_time > 9 && time_stamp - left_cmd_wait_time < 40 && time_stamp - right_cmd_wait_time > 9 && time_stamp - right_cmd_wait_time < 40)
	//if (
	//	(left_init == 1 && time_stamp - left_cmd_wait_time > 9 && time_stamp - left_cmd_wait_time < 40)
	//	|| 
	//	(right_init == 1 && time_stamp - right_cmd_wait_time > 9 && time_stamp - right_cmd_wait_time < 40)
	//	)
	{

		if (rssi < rssi_threshold)
		{
			addMotionCount(ROCK_COUNT);

			result[0] = MOTION_ROCK;

			std::cout << "FingureResult : MOTION_ROCK " << "rssi  ȭͷ"<<endl;
		}
		else
		{
			int pitch_diff = left_att[1] - right_att[1];

			int roll_mean = 0.5f*(left_att[2] + right_att[2]);

			if (pitch_diff - pitch_reference_val > 2000 || pitch_diff - pitch_reference_val < -2000)
			{
				//ͳƼ
				addMotionCount(SCISSORS_COUNT);

				result[0] = MOTION_SCISSORS;

				std::cout << "FingureResult : MOTION_SCISSORS " << " " << endl;

			}
			else if (roll_mean - roll_reference_val > 1500)
			{
				//ͳƲ
				addMotionCount(PAPER_COUNT);

				result[0] = MOTION_PAPER;

				std::cout << "MOTION_PAPER, RSSI : " << rssi << endl;

				std::cout << "FingureResult : MOTION_PAPER" << " " << endl;
			}
			else
			{
				addMotionCount(ROCK_COUNT);

				result[0] = MOTION_ROCK;

				std::cout << "FingureResult : MOTION_ROCK "<< "default ʯͷ" << endl;
			}
		}

		left_cmd_wait_time = 0;
		right_cmd_wait_time = 0;

		left_init = 0;
		right_init = 0;

	}

}
