#include "DanceGame.h"

DanceGame::DanceGame()
{
	left_foot_has_init = 0;
	right_foot_has_init = 0;

	left_heading = 0;
	right_heading = 0;

	left_zupt_count = 0;
	right_zupt_count = 0;

	left_cmd_status = -1;
	right_cmd_status = -1;

	last_left_cmd_status = -1;
	last_right_cmd_status = -1;

	right_cmd_cur_status = -1;
	left_cmd_cur_status = -1;

	memset(left_global_pos, 0, 3 * sizeof(float));
	memset(right_global_pos, 0, 3 * sizeof(float));

	memset(result, -1, 4 * sizeof(int));

	//ԭ
	left_global_pos_vector.push_back({ 0, 0, 0, 0 });
	right_global_pos_vector.push_back({ 0, 0, 0, 0 });

	memset(rssi_buff, 80, 5 * sizeof(int));

}

void DanceGame::setPolarAccUnzupt(int* max_acc, int* min_acc, int* acc, int zupt)
{
	if (zupt != 1)
	{
		for (int i = 0; i < 3; i++)
		{
			if (max_acc[i] < acc[i])
			{
				max_acc[i] = acc[i];
			}

			if (min_acc[i] > acc[i])
			{
				min_acc[i] = acc[i];
			}
		}
	}
	else
	{
		for (int i = 0; i < 3; i++)
		{
			max_acc[i] = acc[i];
			min_acc[i] = acc[i];
		}
	}

}

bool DanceGame::unzuptValid(int* max_acc, int* min_acc)
{
	if (max_acc[0] - min_acc[0] > 1024 || max_acc[1] - min_acc[1] > 1024 || max_acc[2] - min_acc[2] > 1024)
	{
		return true;
	}

	return false;
}

void DanceGame::setData(deque<shoes_data_cell>& shoes_data_vector, int time_stamp, float pos_x, float pos_y, float pos_z, float heading, float pitch, float roll, int zupt, int rssi)
{
	if (shoes_data_vector.size() > 0)
	{
		if (shoes_data_vector.front().zupt == 0)
		{
			shoes_data_vector.clear();
		}
		else if (shoes_data_vector.back().zupt == 1 && zupt == 1)
		{
			shoes_data_vector.clear();
		}
	}
	shoes_data_vector.push_back({ time_stamp,  pos_x,  pos_y,  pos_z, heading, pitch, roll, zupt, rssi });
}

void DanceGame::calGlobalPos(deque<shoes_data_cell>& shoes_data_vector, deque<shoes_data_cell>& step_data_vector, float* global_pos, int LEFT_OR_RIGHT)
{
	int length = shoes_data_vector.size();

	if (length == 0)
	{
		step_data_vector.clear();

		return;
	}

	shoes_data_cell shoes_data_temp = shoes_data_vector.back();

	if (length == 1)
	{
		step_data_vector.clear();

		shoes_data_temp.pos_x = 0;
		shoes_data_temp.pos_y = 0;
		shoes_data_temp.pos_z = 0;

		step_data_vector.push_back(shoes_data_temp);

		return;
	}

	float pos_offset[3];

	pos_offset[0] = shoes_data_vector.at(length - 1).pos_x - shoes_data_vector.at(length - 2).pos_x;
	pos_offset[1] = shoes_data_vector.at(length - 1).pos_y - shoes_data_vector.at(length - 2).pos_y;
	pos_offset[2] = shoes_data_vector.at(length - 1).pos_z - shoes_data_vector.at(length - 2).pos_z;

	float posTemp[3];

	float heading = left_heading;

	if (LEFT_OR_RIGHT == RIGHT_FOOT)
	{
		heading = right_heading;
	}

	posTemp[0] = cos(heading) * pos_offset[0] + sin(heading) * pos_offset[1];
	posTemp[1] = -sin(heading) * pos_offset[0] + cos(heading) * pos_offset[1];


	if (LEFT_OR_RIGHT == LEFT_FOOT)
	{
		/*
		*  ΪЬЬӳģ²򣬻ʹƵX켣䳤
		*/
		pos_offset[0] = rotate_cos * posTemp[0] - rotate_sin * posTemp[1];
		pos_offset[1] = rotate_sin * posTemp[0] + rotate_cos * posTemp[1];
	}
	else
	{
		pos_offset[0] = rotate_cos * posTemp[0] + rotate_sin * posTemp[1];
		pos_offset[1] = -rotate_sin * posTemp[0] + rotate_cos * posTemp[1];
	}

	//pos_offset[0] = posTemp[0];
	//pos_offset[1] = posTemp[1];

	for (int i = 0; i < 3; i++)
	{
		global_pos[i] = global_pos[i] + pos_offset[i];
	}

	shoes_data_temp.pos_x = step_data_vector.back().pos_x + pos_offset[0];
	shoes_data_temp.pos_y = step_data_vector.back().pos_y + pos_offset[1];
	shoes_data_temp.pos_z = step_data_vector.back().pos_z + pos_offset[2];

	std::cout << "global_pos[0] : " << global_pos[0] << " ,global_pos[1] : " << global_pos[1]
		<< " shoes_data_temp.pos_x " << shoes_data_temp.pos_x << "shoes_data_temp.pos_y : " << shoes_data_temp.pos_y << endl;
	step_data_vector.push_back(shoes_data_temp);
}

void ProcessResult(int zupt, int& zupt_count, int& has_init, float heading,
	float& rotate_heading, float* global_pos, deque<shoes_data_cell>& step_data_vector,
	deque<globalPos_struct>& global_pos_vector, int& cmd_status, int LEFT_OR_RIGHT)
{

	if (zupt && step_data_vector.back().rssi < 30)
	{
		zupt_count++;
	}
	else
	{
		zupt_count = 0;
	}

	//Ҫվ1
	if (zupt_count > 15)
	{
		has_init = 1;

		rotate_heading = heading;

		memset(global_pos, 0, 3 * sizeof(float));

		zupt_count = 0;

		if (LEFT_FOOT == LEFT_OR_RIGHT)
		{
			std::cout << "left side " << endl;
		}
		else
		{
			std::cout << "right side " << endl;
		}

		std::cout << "foot_has_init !!!!!" << " heading : " << heading << endl;

	}

	if (has_init == 0)
	{
		memset(global_pos, 0, 3 * sizeof(float));
	}

	if (step_data_vector.size() > 1 && step_data_vector.front().zupt == 1 && step_data_vector.back().zupt == 1)
	{
		if (LEFT_OR_RIGHT == LEFT_FOOT)
		{
			std::cout << "Left Foot : " << endl << endl;
		}
		else
		{
			std::cout << "Right Foot : " << endl << endl;
		}

		//ѰҵСֵ
		int vector_length = global_pos_vector.size();

		float distance_point = 0.15f;

		int index = -1;

		/*	float rotate_pos_1[2];
			float rotate_pos_2[2];

			rotate_pos_1[0] = (step_data_vector.back().pos_x * 0.9856f + step_data_vector.back().pos_y * 0.1692f) + global_pos_vector.back().pos_x;
			rotate_pos_1[1] = (-step_data_vector.back().pos_x * 0.1692f + step_data_vector.back().pos_y * 0.9856) + global_pos_vector.back().pos_y;

			rotate_pos_2[0] = (step_data_vector.back().pos_x * 0.9856f - step_data_vector.back().pos_y * 0.1692f) + global_pos_vector.back().pos_x;
			rotate_pos_2[1] = (step_data_vector.back().pos_x * 0.1692f + step_data_vector.back().pos_y * 0.9856f) + global_pos_vector.back().pos_y;*/

		for (int i = 0; i < vector_length; i++)
		{
			//Ѱȹĵ
			float dx = global_pos[0] - global_pos_vector.at(i).pos_x;
			float dy = global_pos[1] - global_pos_vector.at(i).pos_y;

			//float dx1 = rotate_pos_1[0] - global_pos_vector.at(i).pos_x;
			//float dy1 = rotate_pos_1[1] - global_pos_vector.at(i).pos_y;

			//float dx2 = rotate_pos_2[0] - global_pos_vector.at(i).pos_x;
			//float dy2 = rotate_pos_2[1] - global_pos_vector.at(i).pos_y;

			float distance_temp = sqrt(dx * dx + dy * dy);

			//float distance_temp1 = sqrt(dx1 * dx1 + dy1 * dy1);
			//float distance_temp2 = sqrt(dx2 * dx2 + dy2 * dy2);

			if (distance_temp < distance_point)
				//|| distance_temp1 < distance_point || distance_temp2 < distance_point)
			{
				std::cout << "test : distance_temp < distance_point  : dx " << dx << " , dy" << dy << endl;

				index = i;

				distance_point = distance_temp;

			}
		}


		if (index == -1)
		{
			std::cout << "no find similar point" << endl;
			//ûҵ׼ʱ򣬼⵽ʱ,ж
			//⵽ӽԭʱӦΪ0

			global_pos_vector.push_back({ 0, global_pos[0], global_pos[1],global_pos[2] });

			std::cout << " pos_x : " << global_pos_vector.back().pos_x
				<< " pos_y : " << global_pos_vector.back().pos_y
				<< " pos_z : " << global_pos_vector.back().pos_z << endl;

		}
		else
		{
			std::cout << "has find similar point" << endl;

			global_pos[0] = global_pos_vector.at(index).pos_x;
			global_pos[1] = global_pos_vector.at(index).pos_y;
			global_pos[2] = global_pos_vector.at(index).pos_z;
		}

		std::cout << "cur_pos[0] : " << global_pos[0] << " , " << "cur_pos[1] : " << global_pos[1]
			<< " , " << "cur_pos[2] : " << global_pos[2] << " , " << endl;

		if (sqrt(global_pos[0] * global_pos[0] + global_pos[1] * global_pos[1]) < 0.1f)
		{
			std::cout << "result : " << "MOTION_STEP" << endl;

			global_pos_vector.clear();

			global_pos_vector.push_back({ 0, 0, 0, 0 });

			memset(global_pos, 0, 3 * sizeof(float));

			cmd_status = MOTION_STEP;
		}
		else
		{
			float angle;
			if (LEFT_OR_RIGHT == LEFT_FOOT)
			{
				angle = atan2(global_pos[1], global_pos[0] - 0.1f);
			}
			else
			{
				angle = atan2(global_pos[1], global_pos[0] + 0.1f);
			}

			if (angle > 0.0f && angle < PI * 0.5f)
			{
				cmd_status = MOTION_RIGHT_UP;

				std::cout << "result : " << "RIGHT_UP_POINT" << endl;
			}
			else if (angle > PI * 0.5f - 0.000001f && angle < PI)
			{
				cmd_status = MOTION_LEFT_UP;

				std::cout << "result : " << "LEFT_UP_POINT" << endl;
			}
			else if (angle < 0.000001f && angle > -PI * 0.5f)
			{
				cmd_status = MOTION_RIGHT_DOWN;

				std::cout << "result : " << "RIGHT_DOWN_POINT" << endl;
			}
			else
			{
				cmd_status = MOTION_LEFT_DOWN;

				std::cout << "result : " << "LEFT_DOWN_POINT" << endl;
			}
		}

	}

	//Ϊ˷ֹ󴥵㣬ص

}

void DanceGame::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, LEFT_FOOT);

	memcpy(rssi_buff, rssi_buff + 1, 4 * sizeof(int));

	rssi_buff[4] = rssi;

	/*
	* ͳƲ,ϷֻͳƲ
	*/
	if (left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1
		&& unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		addMotionCount(STEP_COUNT);
	}
	if (right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1
		&& unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		addMotionCount(STEP_COUNT);
	}


	left_cmd_status = -1;
	right_cmd_status = -1;

	ProcessResult(right_zupt, right_zupt_count, right_foot_has_init, right_att[0] * 0.0001f,
		right_heading, right_global_pos, right_step_data_vector,
		right_global_pos_vector, right_cmd_status, RIGHT_FOOT);

	ProcessResult(left_zupt, left_zupt_count, left_foot_has_init, left_att[0] * 0.0001f,
		left_heading, left_global_pos, left_step_data_vector,
		left_global_pos_vector, left_cmd_status, LEFT_FOOT);


	//ͨRSSIжϻع鵽ԭ

	//if (last_left_zupt == 0 && left_zupt == 1 && rssi < rssi_threshold)
	//{
	//	memset(left_global_pos, 0, 3 * sizeof(float));

	//	left_global_pos_vector.clear();

	//	left_global_pos_vector.push_back({ 0,0,0,0 });

	//	left_cmd_status = MOTION_STEP;
	//}
	//if (last_right_zupt == 0 && right_zupt == 1 && rssi < rssi_threshold)
	//{
	//	memset(right_global_pos, 0, 3 * sizeof(float));

	//	right_global_pos_vector.clear();

	//	right_global_pos_vector.push_back({ 0,0,0,0 });

	//	right_cmd_status = MOTION_STEP;
	//}
	if ((((last_right_zupt == 0 && right_zupt == 1 && unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
		|| (last_left_zupt == 0 && left_zupt == 1 && unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))) && rssi < rssi_threshold)
		|| (right_zupt == 1 && left_zupt == 1 && rssi_buff[0] < 23))
	{
		std::cout << "left_zupt == 1 && right_zupt == 1 && rssi < rssi_threshold" << endl;
		memset(left_global_pos, 0, 3 * sizeof(float));
		memset(right_global_pos, 0, 3 * sizeof(float));

		right_global_pos_vector.clear();
		left_global_pos_vector.clear();

		left_global_pos_vector.push_back({ 0,0,0,0 });
		right_global_pos_vector.push_back({ 0,0,0,0 });

		if (last_left_zupt == 0)
		{
			left_cmd_status = MOTION_STEP;
		}

		if (last_right_zupt == 0)
		{
			right_cmd_status = MOTION_STEP;
		}
	}

	if (last_left_cmd_status != left_cmd_status && left_cmd_status != -1)
	{
		result[0] = left_cmd_status;

		left_cmd_cur_status = left_cmd_status;
	}
	else
	{
		result[0] = -1;
	}

	if (last_left_zupt == 1 && left_zupt == 0)
	{
		result[0] = left_cmd_cur_status | MOTION_CANCEL;
	}

	if (last_right_cmd_status != right_cmd_status && right_cmd_status != -1)
	{
		result[1] = right_cmd_status;

		right_cmd_cur_status = right_cmd_status;
	}
	else
	{
		result[1] = -1;
	}

	if (last_right_zupt == 1 && right_zupt == 0)
	{
		result[1] = right_cmd_cur_status | MOTION_CANCEL;
	}


	last_left_cmd_status = left_cmd_status;
	last_right_cmd_status = right_cmd_status;

	last_left_zupt = left_zupt;
	last_right_zupt = right_zupt;

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
}



void DanceGame::getResult(int* dec)
{
	memcpy(dec, result, 4 * sizeof(int));
}

float DanceGame::getGamePos(int left_or_right, int index)
{
	if (index < 0 || index > 2)
		return -1;

	if (left_or_right == LEFT_FOOT)
	{
		return left_global_pos[index];
	}
	else
	{
		return right_global_pos[index];
	}
}