#include "Kongfu.h"


Kongfu::Kongfu()
{
	memset(resultMatrix, -1, 4 * sizeof(int));
	
	last_left_zupt = 1;
	last_right_zupt = 1;

	last_jump = 0;
	last_down = 0;
	
	CANCLE_DOWN = 0;
	CANCLE_JUMP = 0;

	valid_down_wait_time = 0;
	valid_jump_wait_time = 0;

	CANCLE_FLOOR_CMD_LEFT = 0;
	CANCLE_FLOOR_CMD_RIGHT = 0;

	memset(left_global_pos, 0, 3 * sizeof(float));
	memset(right_global_pos, 0, 3 * sizeof(float));

}

void Kongfu::setPolarAccUnzupt(int* max_acc, int* min_acc, int* acc, int zupt)
{
	if (zupt != 1)
	{
		for (int i = 0; i < 3; i++)
		{
			if (max_acc[i] < acc[i])
			{
				max_acc[i] = acc[i];
			}

			if (min_acc[i] > acc[i])
			{
				min_acc[i] = acc[i];
			}
		}
	}
	else
	{
		for (int i = 0; i < 3; i++)
		{
			max_acc[i] = acc[i];
			min_acc[i] = acc[i];
		}
	}

}

bool Kongfu::unzuptValid(int* max_acc, int* min_acc)
{
	if (max_acc[0] > 2048 ||  min_acc[0] < -2048
		|| max_acc[1] > 2048 || min_acc[1] < -2048 || max_acc[2] > 4096 || min_acc[2] < 0)
	{
		return true;
	}

	return false;
}

int getKickByAcc(int zupt, int& kick, int& last_kick, int& kick_wait, float acc_x, vector<float>& acc_x_buff, deque<shoes_data_cell> &shoes_data_vector)
{

	kick = 0;

	acc_x_buff.push_back(acc_x);

	if (zupt)
	{
		acc_x_buff.clear();
	}
	//ڿжһ
	if (shoes_data_vector.size() >  1)
	{
		float start_x = shoes_data_vector.front().pos_x;
		float start_y = shoes_data_vector.front().pos_y;

		float end_x = shoes_data_vector.back().pos_x;
		float end_y = shoes_data_vector.back().pos_y;

		float dx = end_x - start_x;
		float dy = end_y - start_y;

		if (sqrt(dx * dx + dy * dy) > 0.3)
		{
			kick = 1;

			shoes_data_vector.pop_front();
		}

	}
	//xٶжǷ߽, ҽӦǷת
	if (acc_x_buff.size() > 1)
	{
		if (acc_x_buff.back() - acc_x_buff[acc_x_buff.size() - 2] > 0.0f)
		{
			acc_x_buff.clear();
		}
		else
		{
			if (acc_x_buff.front() - acc_x_buff.back() > 3.0f)
			{
				kick = 1;
			}
		}
	}

	//˳жߵĶ
	if (last_kick == 0 && kick == 1)
	{
		kick_wait = 4;
	}

	last_kick = kick;

	if (zupt == 1)
	{
		kick_wait = 0;
	}

	//ݵʱ䳤ȣⴥʱߵĶ
	if ((kick_wait--) == 1)
	{
		return 1;
	}

	return 0;
}

void Kongfu::setData(deque<shoes_data_cell>& shoes_data_vector, int time_stamp, float pos_x, float pos_y, float pos_z, float heading, float pitch, float roll, int zupt, int rssi)
{
	if (shoes_data_vector.size() > 0)
	{
		if (shoes_data_vector.front().zupt == 0)
		{
			shoes_data_vector.clear();
		}
		else if (shoes_data_vector.back().zupt == 1 && zupt == 1)
		{
			shoes_data_vector.clear();
		}
	}
	shoes_data_vector.push_back({ time_stamp,  pos_x,  pos_y,  pos_z, heading, pitch, roll, zupt, rssi });
}


void Kongfu::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	//Ϊ-1
	resultMatrix[0] = -1;
	resultMatrix[1] = -1;

	if (getKickByAcc(left_zupt, left_kick, last_left_kick, left_kick_wait, left_acc[0] / 2048.f, left_acc_x_buff, left_shoes_data_vector)
		&& unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		//ͳߵĶ
		addMotionCount(KICK_COUNT);

		CANCLE_FLOOR_CMD_LEFT = 1;

		resultMatrix[0] = MOTION_LEFT;
	}

	if (getKickByAcc(right_zupt, right_kick, last_right_kick, right_kick_wait, right_acc[0] / 2048.f, right_acc_x_buff, right_shoes_data_vector)
		&& unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		//ͳߵĶ
		addMotionCount(KICK_COUNT);

		CANCLE_FLOOR_CMD_RIGHT = 1;

		resultMatrix[1] = MOTION_RIGHT;
	}


	//ȡ
	if (last_left_zupt == 0 && left_zupt == 1 && unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		//ͳƲ
		addMotionCount(STEP_COUNT);

		if (CANCLE_FLOOR_CMD_LEFT == 0)
		{
			resultMatrix[0] = MOTION_LEFT;
		}
	}


	if (last_left_zupt == 1 && left_zupt == 0)
	{
		CANCLE_FLOOR_CMD_LEFT = 0;
	}


	if (last_right_zupt == 0 && right_zupt == 1 && unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		//ͳƲ
		addMotionCount(STEP_COUNT);

		if (CANCLE_FLOOR_CMD_RIGHT == 0)
		{
			resultMatrix[1] = MOTION_RIGHT;
		}
	}


	if (last_right_zupt == 1 && right_zupt == 0)
	{
		CANCLE_FLOOR_CMD_RIGHT = 0;
	}

	if (resultMatrix[0] == MOTION_LEFT)
	{
		std::cout << "left motion is kick" << endl;
	}

	if (resultMatrix[1] == MOTION_RIGHT)
	{
		std::cout << "right motion is kick" << endl;
	}

	//filter down jump

	if (last_jump == 0 && jump == 1)
	{
		std::cout << "H5GAME:: MOTION_JUMP" << endl;

		resultMatrix[2] = MOTION_JUMP;

		valid_jump_wait_time = WAIT_TIME;
	}
	else
	{
		resultMatrix[2] = -1;
	}

	//reset jump wait time when both foot isn't on the floor
	if ((valid_jump_wait_time > 0 && left_zupt == 0 && right_zupt == 0) || jump == 1)
	{
		valid_jump_wait_time = WAIT_TIME;
	}

	if (valid_jump_wait_time > 0)
	{
		CANCLE_JUMP = 1;

		valid_jump_wait_time--;
	}
	else
	{
		CANCLE_JUMP = 0;
	}


	//same process with jump
	if (last_down == 0 && down == 1 && CANCLE_DOWN == 0)
	{
		std::cout << "H5GAME:: MOTION_DOWN" << endl;

		resultMatrix[3] = MOTION_DOWN;

		valid_down_wait_time = WAIT_TIME;
	}
	else
	{
		resultMatrix[3] = -1;
	}

	//if ((valid_jump_wait_time > 0) || down == 1)
	//{
	//	valid_down_wait_time = WAIT_TIME;
	//}

	if (valid_down_wait_time > 0)
	{
		CANCLE_DOWN = 1;

		if (down == 0)
		{
			valid_down_wait_time--;
		}
	}
	else
	{
		CANCLE_DOWN = 0;
	}


	last_left_zupt = left_zupt;
	last_right_zupt = right_zupt;

	last_jump = jump;
	last_down = down;

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
}


void Kongfu::getResult(int* dec)
{
	memcpy(dec, resultMatrix, 4 * sizeof(int));
}

float Kongfu::getGamePos(int left_or_right, int index)
{
	if (index < 0 || index > 2)
		return -1;

	if (left_or_right == LEFT_FOOT)
	{
		return left_global_pos[index];
	}
	else
	{
		return right_global_pos[index];
	}
}