#include "PublicSDKMotion.h"

class JumpHouse : public PublicSDKMotion
{
	public:
		JumpHouse();

		virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
			int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
			int jump, int down, int rssi);

		bool unzuptValid(int* max_acc, int* min_acc);
	private:

		deque<shoes_data_cell> left_shoes_data_vector;
		deque<shoes_data_cell> right_shoes_data_vector;

		deque<shoes_data_cell> left_step_data_vector;
		deque<shoes_data_cell> right_step_data_vector;

		int left_acc_buff[3][3];
		int right_acc_buff[3][3];

		deque<int> left_back_press_vector;
		deque<int> right_back_press_vector;

		deque<int> left_front_press_vector;
		deque<int> right_front_press_vector;

		int left_press_valid = 0;
		int right_press_valid = 0;

		int left_back_press_offset;
		int right_back_press_offset;

		int left_back_press_detect_time;
		int right_back_press_detect_time;

		float left_heading;
		float right_heading;

		int right_cmd_wait_time;
		int left_cmd_wait_time;

		int left_init;
		int right_init;



		const int rssi_threshold = 25;

};